;#pragma usePoFile 0
; script file for DBT for Windows
; cln, January 11, 2021   
; Copyright Duxbury Systems, Inc.
; All rights reserved.

Include "hjglobal.jsh"
	Include "hjconst.jsh"
			Include "uia.jsh"
	Include "default.jsm"
Include "dbtw.jsh"
Include "dbtw.jsm"
Include "common.jsm"
Include "hjHelp.jsh"
Import "QuickSet.jsd"

globals
	string sWindowName,
	string sOldWindowName,
	int nFocusChange,
	int iLineChange,
	int iFirstWord,
	int MotionFlag,
	int SaySkipFlag,
int nMotionDone,
	int LineNum,
	int OldLineNum,
	string PageNum,
	string OldPageNum,
	int InTable,
	string sRowWord,
	string sRowNum,
	string sOldRowNum,
	string sColWord,
	string sColNum,
	string sOldColNum,
	int BrailleModeSave,
	int BrailleAutoRouteSave,
	int LeftMarginSave,
	int BrailleAutopanSave,
	int nTypingEchoSaved,
	int nFlashMessagesSaved,
	int nG2TranslationSaved,
	int nG2ExpandCurrentWordSaved,
	int nContractedInputSaved,
	int nEightDotSaved,
	int nEchoChange,
	int nBrailleDoc,
	int nBrailleEdit,
	int nOldBrailleEdit,
	int nBrailleStart,
	int nBrailleCharSpokenCol,
	int nInBrailleWindow,
	int nStartCol,
	int nStartRow,
	string StyleName,
	string OldStyleName,
	int DBTWHasRunBefore,
	int nCustomWindow,
	int giBrailleLineSpeakingLevel,
	int gbEchoPC6KeyEntry,
int gbOldEchoPC6KeyEntry,
		int gbAnnounceBrailleCharsAsLocalBrailleSigns,
	int gbStyleChangeVerbosity,
	int gbSkipVerbosity,
	int nJFWVersion,
	int nBrailleTime,
	int iSuppressSameSpot,
	int nWindowTime,
	int nSelectCharacter,
	int nSelectWord,
int nSelectLine,
int nHighlight,
	int nOldHighlight,
	int nHighlightCheck,
	int nNewDoc,
int nProfileIndex,	int iSuppressMulti,

	int nCatchingUp,
	int nYMoved,
	handle SpellCheckWindow,
	int nUsingUIA,
	int nKeysPos,
	int nStartingDBT
	

int function IsSpeechOnDemandActive ()
return (GetJCFOption (OPT_SPEECH_MODE) >= 1 /*|| GetJCFOption (OPT_LESS_SPEECH) == 1*/)
endFunction

void function dbtSpeechOff ()
	if IsSpeechOnDemandActive () return endIf
	SpeechOff ()
endFunction


void function DBTSpeechOn ()
	if IsSpeechOnDemandActive () return endIf
	SpeechOn ()
endFunction

Void Function PauseForMovement ()

	Delay(1)

EndFunction


Void Function AutoStartEvent ()

	DBTSpeechOn ()
LoadNonJCFOptions ()
	if nJFWVersion >= 1700000 then
		let nProfileIndex = GetActiveProfileIndex ()
	endIf
	SetVoicePunctuation (VCTX_KEYBOARD, 3)
	let MotionFlag = 0
	let SaySkipFlag = 0
	let iSuppressSameSpot = 0
	let nStartingDBT = 1
	SendMessage (GetAppMainWindow (GetCurrentWindow ()), 0X0112, /*WM_SYSCOMMAND,*/ 0XF030, 0) /* maximize the window*/
	SendMessage (GetFirstChild (GetFirstChild (GetAppMainWindow (GetCurrentWindow ()))), 0X0112, /*WM_SYSCOMMAND,*/ 0XF030, 0) /* maximize the window*/
	if nBrailleEdit then
		let nBrailleStart = 1
	else
		let nBrailleStart = 0
		let nG2TranslationSaved = GetJCFOption(OPT_BRL_G2TRANSLATION)
		let nTypingEchoSaved = GetJCFOption(OPT_TYPING_ECHO)
		let nCustomWindow = 0
	endIf
	if DBTWHasRunBefore == FALSE then
		SayFormattedMessage (OT_APP_START, msgAppStart, msgAppStart)
		let DBTWHasRunBefore = TRUE
	endIf
	SaveCursor ()
	RouteInvisibleToPc ()
	InvisibleCursor ()
	SetRestriction (RestrictRealWindow)
	JawsPageDown ()
	if GetControlID (GetCurrentWindow ()) != DBT_Window_Control then
		PriorLine ()
	EndIf
	RestoreCursor ()
	if nJFWVersion >= 451000 then
		SetBrailleRestriction (RestrictWindow)
	endIf
	let nInBrailleWindow=0
	if GetWindowClass (GetCurrentWindow ()) != wcMDIClient then
;		let nFocusChange = 3
		HandleCustomWindows (GetCurrentWindow ())
		let nFocusChange = 1
	endIf

EndFunction


Void Function AutoFinishEvent ()

	if nJFWVersion >= 1700000 then
		SetActiveVoiceProfileByIndex (nProfileIndex, False)
	endIf
	
	EndFunction


Script ScriptFileName ()

	ScriptAndAppNames (msgAppName)
		if UserBufferIsActive() then
		UserBufferDeactivate()
	EndIf
	SayFormattedMessage (OT_USER_BUFFER, msgAppTrouble, msgAppTrouble)

EndScript


Script HotKeyHelp ()

	if UserBufferIsActive() then
		UserBufferDeactivate()
	EndIf
	SayFormattedMessage (OT_USER_BUFFER, msgJHotKeyHelp_L,msgJHotKeyHelp_S)

EndScript


Void Function SayBrailleChar (string VCTX, string CurrentChar)

var
	int iVal

	let iVal = GetCharacterValue (CurrentChar)
	if gbAnnounceBrailleCharsAsLocalBrailleSigns == 0 then
		SayUsingVoice (VCTX, CurrentChar, OT_STRING)
		return
	endIf
	if iVal < 48 then
		SayUsingVoice (VCTX, StringSegment (csBrailleChars32, ";", iVal-31),OT_STRING)
		return
	elif iVal <= 64 then
		SayUsingVoice (VCTX, StringSegment (csBrailleChars48, ";", iVal-47), OT_STRING)
		return
	elif iVal < 107 then
		SayUsingVoice (VCTX, StringSegment (csBrailleChars91, ";", iVal-90), OT_STRING)
		return
	elif iVal < 123 then
		SayUsingVoice (VCTX, StringSegment (csBrailleChars107, ";", iVal-106), OT_STRING)
		return
	elif iVal < 128 then
		SayUsingVoice (VCTX, StringSegment (csBrailleChars123, ";", iVal-122), OT_STRING)
		return
	elif iVal < 1088 then
		SayUsingVoice (VCTX, StringSegment (csBrailleChars1072, ";", iVal-1071), OT_STRING)
		return
	elif iVal < 1106 then
		SayUsingVoice (VCTX, StringSegment (csBrailleChars1088, ";", iVal-1087), OT_STRING)
		return
	elif iVal < 10256 then
		SayUsingVoice (VCTX, StringSegment (csBrailleChars10240, ";", iVal-10239), OT_STRING)
		return
	elif iVal < 10272 then
		SayUsingVoice (VCTX, StringSegment (csBrailleChars10256, ";", iVal-10255), OT_STRING)
		return
	elif iVal < 10288 then
		SayUsingVoice (VCTX, StringSegment (csBrailleChars10272, ";", iVal-10271), OT_STRING)
		return
	elif iVal < 10304 then
		SayUsingVoice (VCTX, StringSegment (csBrailleChars10288, ";", iVal-10287), OT_STRING)
		return
	endIf

EndFunction


Void Function FocusPointMovedEvent (int nX, int nY, int nOldX, int nOldY, int nUnit, int nDir, int nTimeElapsed)

var
	int x,
	string sWindowName

	let sWindowName = GetWindowName (GetRealWindow (GetCurrentWindow ()))
;if nSelectingText || nSaySelectAfter then
;	return
;endIf
	
	if not IsDocumentWindow (GetCurrentWindow ())
	&& not StringContains (sWindowName, wnFind)
	&& not StringContains (sWindowName, wnReplace)
	&& not nBrailleEdit
	|| not IsPCCursor ()
	|| MotionFlag
		&& !iLineChange then
		let iFirstWord = 0
		return
	endIf
	if not iFirstWord
	&& not (nBrailleEdit && gbEchoPC6KeyEntry)
	&& not StringContains (GetFromStartOfLine (), " ") then
		let iFirstWord = 1
		SaveOldValues ()
		PauseForMovement ()
		GetNewValues ()
	else
		if not nBrailleEdit then
			return
		endIf
	endIf
	if nFocusChange then
		let MotionFlag = 1
		PauseForMovement ()
	endIf
	if not MotionFlag
	|| iLineChange then
		SaveOldValues ()
	endIf
	if nBrailleEdit
	&& gbEchoPC6KeyEntry then
; in braille doc window, speak last character as braille cell,
		if /*not MotionFlag
		&&*/ nTimeElapsed < 800
		&& nY-nOldY < 50
		&& nOldY-nY < 50
		&& nUnit == 0 then
			;SayBrailleChar (VCTX_KEYBOARD, GetPriorCharacter ())
			SayBrailleChar (VCTX_KEYBOARD, GetLastBrailleInput ())
;			PauseForMovement ()
			if GetWindowClass (GetCurrentWindow ()) == wcDBTWindow then
				let nFocusChange = 0
			endIf
		; below avoid saying "new line" or "space" when starting a Find or Replace command
			if nY != nOldY
			|| nx < nOldX
			&& not nFocusChange then
				if LineNum != -1 then
					SayMessage (OT_KEYBOARD, msgNewLine, msgNewLine)
				endIf
				let nFocusChange = 0
			endIf
			if GetCharacterValue (GetLastBrailleInput ()) == 0 then
				SayMessage (OT_KEYBOARD, msgSpace, msgSpace)
			endIf
		endIf
	endIf
	if /*!MotionFlag
	||*/ iLineChange then
		PauseForMovement ()
		GetNewValues ()
	endIf		

EndFunction


Void Function FocusChangedEvent (handle hWnd, handle hOldWnd)

FocusChangedEvent (hWnd, hOldWnd)
	;if IsDocumentWindow (hWnd) then
	if not DialogActive (1) then
		HandleCustomWindows (hWnd)
	endIf
	if GetWindowClass (hWnd) == wcMDIClient
	&& nCustomWindow <= 1 then
		SayMessage (OT_CONTROL_NAME, msgMdiClient)
	let nCustomWindow = 2
	endIf
		
endFunction
		
		
Int Function MenuModeEvent (handle WinHandle, int mode)

	MenuModeEvent (WinHandle, mode)
	HandleCustomWindows (WinHandle)

	endFunction


Void Function SayCharacterValue ()

var
	int iUnicode,
	string sUnicodeMod

	if not StringIsBlank (GetUnicodeValue ())
	&& IsPCCursor ()then
		SayString (GetUnicodeValue ())
	else
		SayCharacterValue ()
	endIf

endFunction


String Function GetUnicodeValue ()

var
	int iUnicode,
	string sUnicodeMod,
	string sUnicodeValue

	if not IsDocumentWindow (GetCurrentWindow ())
	|| nBrailleEdit then
		return ""
	endIf
	SaveCursor ()
	InvisibleCursor ()
	RouteInvisibleToPc ()
	JawsPageDown ()
	JawsHome ()
	if GetControlID (GetCurrentWindow ()) != DBT_Window_Control then
		PriorLine ()
	EndIf	
	let iUnicode = StringContains (GetLine (), scUnicode)
	if iUnicode == 0 then
		RestoreCursor ()
		return ""
	else
		let sUnicodeValue = SubString(GetLine(), iUnicode+StringLength (scUnicode), 4)
		RestoreCursor ()
		return sUnicodeValue
	EndIf

EndFunction

string Function GetColumnNum ()

var
	int iCol,
	string sColMod

	SaveCursor ()
	InvisibleCursor ()
	RouteInvisibleToPc ()
	JawsPageDown ()
	JawsHome ()
	if GetControlID (GetCurrentWindow ()) != DBT_Window_Control then
		PriorLine ()
	EndIf	
	let iCol = StringContains (GetLine (), scCol)
	if iCol == 0 then
		RestoreCursor ()
		return -1
	else
		let sColMod = SubString (GetLine (), iCol + StringLength (scCol), 3)
		RestoreCursor () ;SayInteger (iColMod)
		return sColMod
	EndIf

EndFunction


Int Function GetLineNum ()

var
	int iLine,
	int iLineMod,
	int iScLineLength = StringLength (scLine),
	int iCol

	SaveCursor ()
	InvisibleCursor ()
	RouteInvisibleToPc ()
	JawsPageDown ()
	JawsHome ()
	if GetControlID (GetCurrentWindow ()) != DBT_Window_Control then
		PriorLine ()
	EndIf	
	let iLine = StringContains (GetLine (), scLine)
	if iLine == 0 then
		RestoreCursor ()
		return -1
	else
		let iCol = StringContains(GetLine (), scCol)
		let iLineMod = StringToInt (SubString (GetLine (), iLine + iScLineLength, iCol-iLine-iScLineLength))
		RestoreCursor ()
		return iLineMod
	EndIf

EndFunction


String Function GetPageNum ()

var
	int iPage,
	int iScPageLength = StringLength (scPage),
	int iLine,
	string sPageMod

	if not IsDocumentWindow (GetCurrentWindow ()) then
		return ""
	endIf
	SaveCursor ()
	InvisibleCursor ()
	RouteInvisibleToPc ()
	SetRestriction (RestrictRealWindow)
	JawsPageDown ()
	if GetControlID (GetCurrentWindow ()) != DBT_Window_Control then
		PriorLine ()
	EndIf
	JawsHome ()
	let iPage = StringContains (GetLine (), scPage)
	if iPage == 0 then
		RestoreCursor ()
		return -1
	else
		let iLine = StringContains (GetLine (), scLine)
		let sPageMod = SubString (GetLine (), iPage+iScPageLength, iLine-iPage-iScPageLength)
		RestoreCursor ()
		return sPageMod
	EndIf

EndFunction


String Function GetStyleName ()

var
	int iLabel,
	string sStyle,
	int i

	if not IsDocumentWindow (GetCurrentWindow ()) then
		return
	endIf
	SaveCursor ()
	RouteInvisibleToPc ()
	InvisibleCursor ()
	SetRestriction (RestrictRealWindow)
	JawsPageDown ()
	if GetControlID (GetCurrentWindow ()) != DBT_Window_Control then
		PriorLine ()
	EndIf	
;while GetWindowClass(GetCurrentWindow ()) != wcDBTWindow
;	PriorLine ()
;EndWhile	
	JawsHome ()
	let iLabel = StringContains (GetLine (), scCurrentStyle)
	if iLabel == 0 then
		let iLabel = StringContains (GetLine (), scRow)
	endIf
	if iLabel == 0 then
		RestoreCursor ()
		return msgSilent
	else
		if iLabel == 1 then
			let InTable = 0
			let sStyle = StringChopLeft (GetChunk (), stringLength (scCurrentStyle))
		else
			let InTable = 1
			let sStyle = StringLeft (GetLine (), iLabel-1)
			let i = 0
			JAWSHome ()
			while i < iLabel
				NextCharacter ()
				let i = i+1
			endWhile
			NextWord ()
			let sRowWord = GetWord ()
			NextWord ()
			NextWord()
			let sColWord = GetWord ()
			let sRowNum = StringSegment (sRowWord, "/", 1)
			let sColNum = StringSegment (sColWord, "/", 1)
		endIf
;	RestoreCursor ()
		return sStyle
	endIf

EndFunction


Script AltF3Press ()

	if not StringContains (GetWindowName (GetRealWindow (GetCurrentWindow ())), scDocument) then
		SayUsingVoice (VCTX_MESSAGE, msgNotInDocument, OT_USER_REQUESTED_INFORMATION)
		return
	endIf
; to avoid giving incorrect message because of a timing lag,
; look at status line before sending Alt+F3 to the application
;SayInteger (GetLineNum ()) ;5/21/2013
	if GetLineNum() != -1 then
		SayMessage (OT_STATUS, msgCodesOn_l, msgCodesOn_s)
	else
		SayMessage (OT_STATUS, msgCodesOff_l, msgCodesOff_s)
	endIf
	TypeCurrentScriptKey ()

EndScript


Script F2Press ()

var
	string sLine

	if not IsDocumentWindow (GetCurrentWindow ()) then
; previously just said "not in document window" with no change of setting,
; but now we change setting even though script can't announce it properly
		TypeCurrentScriptKey ()
		return
	endIf
	TypeCurrentScriptKey ()
	PauseForMovement ()
	SaveCursor ()
	InvisibleCursor ()
	RouteInvisibleToPc ()
	JawsPageDown ()
	if GetControlID (GetCurrentWindow ()) != DBT_Window_Control then
		PriorLine ()
	EndIf	
	let sLine = GetLine ()
	let nKeysPos = StringContains (sLine, scKeys)
	if SubString (sLine, nKeysPos+5, 1) == "6" then
		SayMessage (OT_STATUS, msgPerkinsOn, msgPerkinsOn) 
	else
		SayMessage (OT_STATUS, msgPerkinsOff, msgPerkinsOff)
	endIf
	RestoreCursor ()

EndScript


Script ControlF8Press ()

var
	handle hndTransLine,
	int nTransLineCheck,
	int NoBackTrans

	if not StringContains (GetWindowName (GetRealWindow (GetCurrentWindow ())), scDocument) then
		SayUsingVoice (VCTX_MESSAGE, msgNotInDocument, OT_USER_REQUESTED_INFORMATION)
		return
	endIf
	let NoBackTrans = 0
	TypeCurrentScriptKey ()
	PauseForMovement ()
	let nTransLineCheck = CheckTransLine ()
	if nTransLineCheck == 1 then
		SayMessage (OT_STATUS, msgTransLineOn, msgTransLineOn)
	elif nTransLineCheck == 0 then
		SayMessage (OT_STATUS, msgTransLineOff, msgTransLineOff)
	elif nTransLineCheck == -1 then
		SayMessage (OT_SCREEN_MESSAGE, msgTransTableError, msgTransTableError)
		endIf

endScript


Void Function SayHighlightedText (handle hwnd, string buffer)

;var
;	string sWindowName

	let sWindowName = GetWindowName (GetRealWindow (GetCurrentWindow ()))
	if sWindowName == wnSpellCheck then
	SayMessage (OT_USER_REQUESTED_INFORMATION, buffer)
	SayMessage (OT_STATUS, msgSpelled, msgSilent)
	SpellString (buffer)
	if GetObjectTypeCode () == WT_BUTTON then
;		RouteInvisibleToPC ()
		ReadContextLine ()
;		PCCursor ()
	endIf
elIf sWindowName == wnConfirmReplacement then
	if GetObjectTypeCode () == WT_BUTTON then
;		RouteInvisibleToPC ()
		ReadContextLine ()
;		PCCursor ()
	endIf
Else SayHighlightedText (hwnd, buffer)
endIf

EndFunction


Script SayLine ()

var
	int nTimesPressed

	let nTimesPressed = IsSameScript ()
	if nTimesPressed > 0 then
;		let MotionFlag=1
		PerformScript SayLine()
		return
	endIf
	if MenusActive ()
	|| GetWindowClass (GetCurrentWindow ()) != wcDBTWindow
	|| Not IsPcCursor () then
		PerformScript SayLine ()
		return
	endIf
	GetNewValues ()
	SpeakLineOfText ()

EndScript


Void Function SayLineUnit (int UnitMovement)

	if IsDocumentWindow(GetCurrentWindow ())
	&& IsPCCursor () then
		let iSuppressMulti = 1
		SpeakLineOfText ()
		let MotionFlag = 1
		let SaySkipFlag = 1
;let nStartCol = GetCursorCol ()
;let nStartRow = GetCursorRow ()
		let iSuppressMulti = 0
	else SayLineUnit (UnitMovement)
	endIf

EndFunction


Script SayNextLine ()

	if not IsDocumentWindow (GetCurrentWindow ()) then
;	|| not IsPCCursor () then
		PerformScript SayNextLine ()
		return
	endIf
	if nHighlight then
		PerformScript SelectNextLine()
		return
	endIf
	SaveOldValues ()
	let SaySkipFlag = 1
	NextLine ()
	PauseForMovement ()
	GetNewValues ()
	SpeakLineOfText ()

EndScript


Script BrailleNextLine ()

	if GetJCFOption (OPT_BRL_MOVE_ACTIVE_CURSOR) == 1 then
		SaveOldValues ()
		let SaySkipFlag = 1
		NextLine ()
		PauseForMovement ()
		GetNewValues ()
	else PerformScript BrailleNextLine()
	endIf

EndScript

Script SayPriorLine ()	

	if MenusActive () then
		PriorLine ()
		return
	endIf
	if not IsDocumentWindow (GetCurrentWindow ()) then
;	|| Not IsPcCursor () then
		PauseForMovement ()
		PerformScript SayPriorLine ()
		return
	endIf
	if nHighlight then
		PerformScript SelectPriorLine()
		return
	endIf
	SaveOldValues ()
	let SaySkipFlag = 1
	PriorLine ()
	PauseForMovement ()
	GetNewValues ()
	SpeakLineOfText ()

EndScript


Script BraillePriorLine ()

	if GetJCFOption (OPT_BRL_MOVE_ACTIVE_CURSOR) == 1 then
		SaveOldValues ()
		let SaySkipFlag = 1
		PriorLine ()
		PauseForMovement ()
		GetNewValues ()
	else PerformScript BraillePriorLine ()
	endIf

EndScript


Script BottomOfFile ()

	if MenusActive ()
	|| GetWindowClass (GetCurrentWindow ()) != wcDBTWindow
	|| Not IsPcCursor () then
		PerformScript BottomOfFile ()
		return
	endIf
	PerformScript ChangeLine()

EndScript


Script TopOfFile ()

	if MenusActive ()
	|| GetWindowClass (GetCurrentWindow ()) != wcDBTWindow
	|| Not IsPcCursor () then
		PerformScript TopOfFile ()
		return
	endIf
	PerformScript ChangeLine()

EndScript


Script JAWSPageDown ()

	if MenusActive ()
	|| GetWindowClass (GetCurrentWindow ()) != wcDBTWindow
	|| Not IsPcCursor () then
		PerformScript JAWSPageDown ()
		return
	endIf
	PerformScript ChangeLine()

EndScript


Script JAWSPageUp ()

	if MenusActive ()
	|| GetWindowClass (GetCurrentWindow ()) != wcDBTWindow
	|| Not IsPcCursor () then
		PerformScript JawsPageUp ()
		return
	endIf
	PerformScript ChangeLine()

EndScript


Script ChangeLine ()

	if MenusActive ()
	|| GetWindowClass (GetCurrentWindow ()) != wcDBTWindow
	|| Not IsPcCursor () then
		TypeCurrentScriptKey ()
		PauseForMovement ()
		SayLine ()
		return
	endIf
	SaveOldValues ()
	TypeCurrentScriptKey ()
	PauseForMovement ()
	GetNewValues ()
	SpeakLineOfText ()

EndScript


Void Function SpeakLineOfText ()

	if StringIsBlank (GetLine ())
	&& IsDocumentWindow (GetCurrentWindow ()) then
		SayUsingVoice (VCTX_MESSAGE, msgBlank, OT_TEXT)
		return
	endIf
	if not nBrailleDoc /*|| giBrailleLineSpeakingLevel*/ then
		SayLine ()
	elif giBrailleLineSpeakingLevel==1 then
		if BrailleInUse () then
			BrailleLine ()
		endIf
	SpeakLineAsBrailleCells (GetLine ())
	elif giBrailleLineSpeakingLevel==2 then
		let nCatchingUp = 1
		PerformScript SpeakTransLine ()
		while nCatchingUp
		&& not IsKeyWaiting ()
		let nCatchingUp = nCatchingUp-1
			PerformScript SpeakTransLine()
		endWhile
	endIf

EndFunction

Int Function DecipherItemOfText ()

var
	string CharacterCheck,
	String StringCheck,
	string FontCheck,
	string sStyleName,
	string nVersion

	if GetCursorCol () == nStartCol
	&& GetCursorRow () == nStartRow
;	&& not iSuppressSameSpot
	&& GetPageNum () != -1
		PlaySound (FindJAWSSoundFile ("tonguethump.wav"))
		return 1
	endIf
	if GetPageNum () != -1 then
		return 1
	endIf
	if GetCharacter () == "[" then
		NextCharacterSelectIfOn ()
		;PauseForMovement ()
		RouteInvisibleToPc ()
				PauseForMovement ()
		InvisibleCursor ()
		let CharacterCheck = GetPriorCharacter ()
		PCCursor ()
			PriorCharacterSelectIfOn ()
			;PauseForMovement ()
			if CharacterCheck != "[" then
				SayMessage (OT_TEXT, msgCode, msgCode)
				SpellString (StringChopLeft (StringSegment (GetToEndOfLine (), "]", 1), 1))
				return 0
				else return 1
			endIf
	elIf StringIsBlank (GetFont ())
		&& StringContains (GetToEndOfLine (), "[") == 1 then
		SayMessage (OT_TEXT, msgCode, msgCode)
		SpellString (StringChopLeft (StringSegment (GetToEndOfLine (), "]", 1), 1))
		return 0
	elif GetCharacter () == "<" then
		NextCharacterSelectIfOn ()
		;PauseForMovement ()
		RouteInvisibleToPc ()
				PauseForMovement ()
		InvisibleCursor ()
		let CharacterCheck = GetPriorCharacter ()
		PCCursor ()
		PriorCharacterSelectIfOn ()
		;Pause ForMovement()
		if CharacterCheck != "<" then
			let sStyleName = (StringChopLeft (StringSegment (GetToEndOfLine (), ">", 1), 1))
			if StringLeft (sStyleName, 1) == "/" then
				SayUsingVoice (VCTX_KEYBOARD, msgEndStyle+" "+(StringChopLeft (sStyleName, 1)), OT_TEXT)
			else
				SayUsingVoice (VCTX_KEYBOARD, msgBeginStyle+" "+sStyleName, OT_TEXT)
			endIf
			return 0
		else return 1 
		endIf
	/* section below is for a code or style code at the start of a line
	following a code or style code at the end of the previous line */
	elif GetColorBackground () == 0
	&& StringIsBlank (GetFont ())
	&& not nHighlight
	&& GetLineNum () == -1 then
		if StringLength (GetToEndOfLine ()) == 0 then
			SaveCursor ()
			RouteInvisibleToPc ()
			NextLine ()
			JawsHome ()
			let CharacterCheck = GetCharacter ()
			let StringCheck = GetToEndOfLine ()
			PcCursor ()
			RestoreCursor ()
		Pause ()
		else let StringCheck = GetToEndOfLine ()
			let CharacterCheck = SubString (StringCheck, 1, 1)
		endIf
		if CharacterCheck == "<" then
			SayMessage (OT_TEXT, msgStyle, msgStyle)
			SayString (StringChopLeft (StringSegment (StringCheck, ">", 1), 1))
		elif CharacterCheck == "[" then
			SayMessage (OT_TEXT, msgCode, msgCode)
			SpellString (StringChopLeft (StringSegment (StringCheck, "]", 1), 1))
		else SayMessage (OT_TEXT, msgSpace, msgSpace)
		endIf
		return 0
	endIf
;Below speak verbose labels for DBT versions before 11.2.
	if GetCharacter () == "{" then
		let nVersion = GetVersionInfoString (GetAppFilePath (), "ProductVersion")
		if StringStartsWith (nVersion, "11.1")
		|| StringStartsWith (nVersion, "10") then
			NextCharacterSelectIfOn ()
			Pause ()
			let CharacterCheck = GetPriorCharacter ()
			PriorCharacterSelectIfOn ()
			Pause ()
			if CharacterCheck != "{" then
				SayString (StringChopLeft (StringSegment (GetToEndOfLine (), "}", 1), 1))
				return 0
			else return 1
			endIf
		else SayTheCharacter ()
		endIf
		return 0
	endIf
	return 1

endFunction


Void Function NextCharacterSelectIfOn ()

	if nSelectingText
	&& !nHighlight then
		DBTSpeechOff ()
		SelectNextCharacter ()
		DBTSpeechOn ()
	else NextCharacter ()
	endIf

EndFunction


Void Function PriorCharacterSelectIfOn ()

	if nSelectingText
	&& !nHighlight then
		DBTSpeechOff ()
		SelectPriorCharacter ()
		DBTSpeechOn ()
	else PriorCharacter ()
	endIf

EndFunction


Void Function NextWordSelectIfOn ()

	if nSelectingText
	&& !nHighlight then
		/*DBT*/SpeechOff ()
		SelectNextWord ()
		/*DBT*/SpeechOn ()
	else NextWord ()
	endIf

EndFunction


Void Function PriorWordSelectIfOn ()

	if nSelectingText
	&& !nHighlight then
		DBTSpeechOff ()
		SelectPriorWord ()
		DBTSpeechOn ()
	else PriorWord ()
	endIf

EndFunction

Script SayWord ()

var
	int nTimesPressed,
	int nL,
	string sString1,
	string sString2

	let nTimesPressed = IsSameScript ()
	if nTimesPressed > 0
	&& not iSuppressMulti then
		PerformScript SayWord()
		return
	endIf
	let iSuppressMulti = 0
	if not IsDocumentWindow (GetCurrentWindow ())
	|| Not IsPcCursor () then
		PerformScript SayWord()
		return
	endIf
	if DecipherItemOfText () == 0 then
		return
	endIf
	if nBrailleDoc then
		SpeakWordAsBrailleCells (GetToEndOfLine ())
	else
		let sString1 = GetToEndOfLine ()
		NextWordSelectIfOn ()
		let sString2 = GetToEndOfLine ()
		PriorWordSelectIfOn ()
		let nL = StringContains (sString1, sString2)
		if nL > 0 then
			SayUsingVoice (VCTX_PCCURSOR, Substring (GetToEndOfLine (), 1, nL-1), OT_WORD)
		else SayUsingVoice (VCTX_PCCURSOR, sString1, OT_WORD)
		endIf
	endIf

EndScript


Void Function SayWordUnit (int UnitMovement)

	if IsDocumentWindow(GetCurrentWindow ())
	&& IsPCCursor () then
		let iSuppressMulti = 1
		PerformScript SayWord ()
		let MotionFlag = 1
		let SaySkipFlag = 1
;let nStartCol = GetCursorCol ()
;let nStartRow = GetCursorRow ()
		let iSuppressMulti = 0
	else SayWordUnit (UnitMovement)
	endIf


EndFunction


Script SayNextWord ()

	if MenusActive () then
		NextWord ()
		return
	endIf
	if not IsDocumentWindow (GetCurrentWindow ())
	|| Not IsPcCursor () then
		PauseForMovement ()
		PerformScript SayNextWord ()
		return
	endIf
	if nHighlight then
		PerformScript SelectNextWord ()
		return
	endIf
	let MotionFlag = 1
	if GetPageNum () == -1 then
		let iLineChange = 0
	else
		let nStartCol = GetCursorCol ()
		let nStartRow = GetCursorRow ()
		if StringIsBlank (GetToEndOfLine ()) then
			let iLineChange = 1
			SaveOldValues ()
			let SaySkipFlag = 1
		else let iLineChange = 0
		endIf
	endIf
	NextWord ()
	if iLineChange then
		GetNewValues ()
	endIf
	if DecipherItemOfText () == 0 then
		return
	endIf
	let iSuppressMulti = 1
	PerformScript SayWord()

EndScript


Script SayPriorWord ()

	if MenusActive () then
		PriorWord ()
		return
	endIf
	if not IsDocumentWindow (GetCurrentWindow ())
	|| Not IsPcCursor () then
		PauseForMovement ()
		PerformScript SayPriorWord ()
		return
	endIf
	if nHighlight then
		PerformScript SelectPriorWord()
		return
	endIf
	let MotionFlag = 1
	if GetPageNum () == -1 then
		let iLineChange = 0
	else
		let nStartCol = GetCursorCol ()
		let nStartRow = GetCursorRow ()
		if StringIsBlank (GetFromStartOfLine ()) then
			let iLineChange = 1
			SaveOldValues ()
			let SaySkipFlag = 1
		endIf
	endIf
	PriorWord ()
	if iLineChange == 1 then
		GetNewValues ()
	endIf
	if DecipherItemOfText () == 0 then
		return
	endIf
	let iSuppressMulti = 1
	PerformScript SayWord()

EndScript


Script SayCharacter ()

var
	int nTimesPressed

	let nTimesPressed = IsSameScript ()
	if nTimesPressed > 0
	&& not iSuppressMulti then
		let MotionFlag=1
		PerformScript SayCharacter()
		return
	endIf
	if MenusActive () then
		SayCharacter ()
		return/*PerformScript AcceptLocator ()*/
	endIf
	If IsJawsCursor ()
	&& GetWindowClass (GetCurrentWindow ()) == wcDBTWindow then
		if Not IsPointInWindow (GetFirstWindow (GetCurrentWindow ()), GetCursorCol (), GetCursorRow ()) then
			SayBrailleChar (VCTX_PCCURSOR, GetCharacter ())
			return
			
		EndIf
	EndIf
	if GetWindowClass (GetCurrentWindow ()) != wcDBTWindow
	|| Not IsPcCursor () then
		PerformScript SayCharacter ()
		return
	endIf
	if DecipherItemOfText () == 0 then
		return
	endIf
	SayTheCharacter ()

EndScript


Void Function SayCharacterUnit (int UnitMovement)

	if IsDocumentWindow(GetCurrentWindow ()) then
		let iSuppressMulti = 1
		PerformScript SayCharacter ()
		let MotionFlag = 1
		let nStartCol = GetCursorCol ()
		let nStartRow = GetCursorRow ()
		let iSuppressMulti = 0
	else SayCharacterUnit (UnitMovement)
	endIf



EndFunction


Void Function SayTheCharacter ()

var
	int i1,
	int i2

	if (GetCharacter () == " ")
	&& StringLength (GetToEndOfLine ()) == 0 then
; distinguish between space within group of trailing spaces vs. a space really at the end of the line
		SaveCursor ()
		RouteInvisibleToPC ()
		InvisibleCursor ()
		let i1 = GetCursorCol ()
			JAWSEnd ()
		let i2 = GetCursorCol ()
		if i1 == i2 /*&& GetLineNum () != -1*/ then
			SayMessage (OT_TEXT, msgSpaceAtEndOfLine, msgSpaceAtEndOfLine)
		else SayMessage (OT_TEXT, msgSpace, msgSpace)
		endIf
		PCCursor ()
		RestoreCursor ()
		return
	endIf
	if (GetCharacter () == " "
	|| GetUnicodeValue () == "0020") then
		SayMessage (OT_TEXT, msgSpace, msgSpace)
		return
	endIf
	if not StringIsBlank (GetUnicodeValue ()) then
		SpellString (MakeCharacterFromValue (HexToDec (GetUnicodeValue ())))
		return
	endIf
	if not nBrailleEdit then
		SayCharacter ()
	elif StringIsBlank (GetFont ()) then
		SayMessage (OT_TEXT, msgBlank, msgBlank)
	else SayBrailleChar (VCTX_PCCURSOR, GetCharacter ())
	endIf
		RouteInvisibleToPC ()
		InvisibleCursor ()
		let i1 = GetCursorCol ()
			JAWSEnd ()
		let i2 = GetCursorCol ()
; disabled lines below to avoid hearing message when backspacing
;		if i1 == i2 && GetLineNum () != -1 then
;			SayMessage (OT_TEXT, msgEndOfLine, msgEndOfLine)
;		endIf
		PCCursor ()
		RestoreCursor ()

EndFunction


Script SayNextCharacter ()

	if MenusActive () then
		PerformScript SayNextCharacter ()
		return
	endIf
	If IsJawsCursor ()
	&& GetCurrentWindow () == GetNextWindow (GetNextWindow (GetFocus ())) then
		SayNextCharacterTranslatedLine ()
		return
	endIf
	if not IsDocumentWindow (GetCurrentWindow ())
	&& not (GetWindowClass (GetCurrentWindow ()) == wcDBTCodesEdit)
	|| Not IsPcCursor () then
		PauseForMovement ()
		PerformScript SayNextCharacter ()
		return
	endIf
	if nHighlight then
		PerformScript SelectNextCharacter()
		return
	endIf
	let MotionFlag = 1
	if GetPageNum () == -1
		let iLineChange = 0
	else
		let nStartCol = GetCursorCol ()
		let nStartRow = GetCursorRow ()
		if StringIsBlank (GetToEndOfLine ()) then
			let iLineChange = 1
			SaveOldValues ()
			let SaySkipFlag = 1
		else let iLineChange = 0
		endIf
	endIf
	NextCharacter ()
	if iLineChange then
		GetNewValues ()
	endIf
	if DecipherItemOfText () == 0 then
		return
	endIf
	SayTheCharacter ()

EndScript


Script SayPriorCharacter ()

	if MenusActive () then
		PerformScript SayPriorCharacter ()
		return
	endIf
	If IsJawsCursor ()
	&& GetCurrentWindow () == GetNextWindow (GetNextWindow (GetFocus ())) then
		SayPriorCharacterTranslatedLine ()
		return
	endIf
	if not IsDocumentWindow (GetCurrentWindow ())
	&& not (GetWindowClass (GetCurrentWindow ()) == wcDBTCodesEdit)
	|| Not IsPcCursor () then
		PauseForMovement ()
		PerformScript SayPriorCharacter ()
		return
	endIf
	if nHighlight then
		PerformScript SelectPriorCharacter()
		return
	endIf
	let MotionFlag = 1
	if GetPageNum () == -1 then
		let iLineChange = 0
	else let nStartCol = GetCursorCol ()
		let nStartRow = GetCursorRow ()
		if StringIsBlank (GetFromStartOfLine ()) then
			let iLineChange = 1
			SaveOldValues ()
			let SaySkipFlag = 1
		endIf
	endIf
	PriorCharacter ()
	if iLineChange == 1 then
		GetNewValues ()
	endIf
	let iLineChange = 0
	if DecipherItemOfText () == 0 then
		return
	endIf
	SayTheCharacter ()

EndScript


Void Function SayNextCharacterTranslatedLine ()

	NextCharacter ()
	if IsBrailleDocumentWindow (GetCurrentWindow ()) then
		SayCharacter ()
	else
SayBrailleChar (VCTX_JAWSCURSOR, GetCharacter ())
	EndIf

	if StringLength (GetToEndOfLine ()) == 1 then
		SayMessage (OT_STATUS, msgEndLine, msgEndLine)
	endIf

EndFunction 	


Void Function SayPriorCharacterTranslatedLine ()

		PriorCharacter ()
	if IsBrailleDocumentWindow (GetCurrentWindow ()) then
		SayCharacter ()
	else
SayBrailleChar (VCTX_JAWSCURSOR, GetCharacter ())
	EndIf
	if StringLength (GetFromStartOfLine ()) == 0 then
		SayMessage (OT_STATUS, msgStartLine, msgStartLine)
	endIf

EndFunction


Script SayDocName ()

;HandleCustomWindows (GetCurrentWindow ())
	if not StringContains (GetWindowName (GetRealWindow (GetCurrentWindow())), scDocument) then
		SayUsingVoice (VCTX_MESSAGE, msgNotInDocument, OT_USER_REQUESTED_INFORMATION)
	else
		Say (GetWindowName (GetRealWindow (GetCurrentWindow ())), OT_USER_REQUESTED_INFORMATION)
	endIf

EndScript


Int Function CheckTransLine ()

var
	handle hndDocument,
	handle hndTransLine,
	int nTransLineShowing

	let nTransLineShowing = 0
	let hndDocument = GetCurrentWindow ()
	SaveCursor ()
	InvisibleCursor ()
	let hndTransLine = GetNextWindow (GetNextWindow (hndDocument))
	MoveToWindow (hndTransLine)
	if StringLength(GetWindowText (GetCurrentWindow (), 0)) <= StringLength(GetLine ()) +4 then
		if GetLine () == scErrorMessage0 then
			let nTransLineShowing = -1
			else let nTranslineShowing = 1
	endIf
	else let nTransLineShowing = 0
;		Say ("window: "+IntToString(StringLength(GetWindowText (GetCurrentWindow (), 0)))+"; line: "+IntToString(StringLength (GetLine ())), OT_POSITION, FALSE) 
	endIf
	return nTransLineShowing

EndFunction


Script SpeakTransLine ()

var
	handle hndTransLine,
	string CurLine,
	int NOBackTrans,
	int VoiceRate,
	int xPos,
	int DelayCounter,
	int BrailleModeSave,
	int nTransLineCheck,
	int nPanTime,
	string sTransLine,
	string buffer

	if GetCurrentScriptKeyName () == ksSpeakTransLine then
		if not StringContains (GetWindowName (GetRealWindow (GetCurrentWindow ())), scDocument) then
			SayUsingVoice (VCTX_MESSAGE, msgNotInDocument, OT_USER_REQUESTED_INFORMATION)
			return
	endIf
;	let NoBackTrans = 0
	endIf
	if not CheckTransLine () then
		PauseForMovement ()
		if not CheckTransLine () then
			TypeKey ("Control+F8")
			SayMessage (OT_STATUS, msgTransLineOn, msgTransLineOn)
			PauseForMovement () 
		endIf
	endIf
	let hndTransLine = GetNextWindow (GetNextWindow (GetCurrentWindow ()))
	let sTransLine = GetWindowText (hndTransLine, 0)
	if nBrailleEdit then
		if not IsDocumentWindow (GetCurrentWindow ())
		&& not IsKeyWaiting () then
;			SayUsingVoice (VCTX_MESSAGE, msgCatchingUp, OT_STATUS)
			let nCatchingUp = 2
			return
		elif nCatchingUp == 1 then
			return
		endIf
/*		If StringContains (sTransLine, scErrorMessage0) then
			let NOBackTrans = 1
			let DoNotForceTransLine = 1
			SayMessage (OT_SCREEN_MESSAGE, msgTransTableError, msgTransTableError)
			SayMessage (OT_JAWS_MESSSAGE, msgReadBrailleLinesAsEnglishBrailleChars, msgReadBrailleLinesAsEnglishBrailleChars)
			return
		endIf*/
		if not nCatchingUp then
		SayString (sTransline)
		endIf
		return
	endIf
	SaveCursor ()
	InvisibleCursor ()
	MoveToWindow (hndTransLine)
	SpeakStringAsBrailleCells (VCTX_JAWSCURSOR, sTransLine)
	RestoreCursor ()
	PcCursor ()
	return

EndScript

Void Function SpeakWordAsBrailleCells (string sBrailleText)

var
	int i,
	string sNextWord

	let i = 1
	NextWordSelectIfOn ()
	let sNextWord = GetToEndOfLine ()
	PriorWordSelectIfOn ()
	while (i <= StringLength (sBrailleText))
		if SubString (sBrailleText, i, 1) == " " || StringChopLeft (sBrailleText, i-1) == sNextWord then
			return
		endIf
		SayBrailleChar (VCTX_PCCURSOR, SubString (sBrailleText, i, 1))
		let i = i+1
		Delay (3)
	endWhile

EndFunction


Void Function SpeakLineAsBrailleCells (string  sBrailleLine)

var
	int i

	if StringIsBlank (GetLine ()) then
		SayMessage (OT_TEXT, msgBlank)
		return
	endIf
	if GetLineNum () != -1 then
		SpeakStringAsBrailleCells (VCTX_PCCURSOR, GetLine ())
;		SpeakStringAsBrailleCells (VCTX_PCCURSOR, StringTrimLeadingBlanks (GetLine ())
		return
	endIf
	JAWSHome ()
	PerformScript SayWord ()
	NextWord ()
	while StringLength (StringTrimLeadingBlanks (GetFromStartOfLine ())) > 0 && not IsKeyWaiting ()
		PerformScript SayWord ()
		NextWord ()
		Delay (2)
	endWhile
	PriorCharacter ()
	PriorCharacter ()
	JAWSHome ()

EndFunction


Void Function SpeakStringAsBrailleCells (string VCTX, string sBrailleText)

var
	int i,
	int j,
	int iStringLength

	let i = 1
	let iStringLength = StringLength (sBrailleText)
	while i <= iStringLength
	&& not IsKeyWaiting ()
		if Substring (sBrailleText, i, 1) == " "
		&& Substring (sBrailleText, i+1, 1) == " " then
			let j = StringLength (StringChopLeft (sBrailleText, i)) - StringLength (StringTrimLeadingBlanks (StringChopLeft (sBrailleText, i)))+1
			Say (IntToString (j)+"spaces", FALSE)
			let i = i+j
		else
			SayBrailleChar (VCTX, Substring(sBrailleText, i, 1))
			Delay (3)
			let i = i+1
		endIf
	endWhile

EndFunction

Script TransLineCursorToggle ()

var
	int nTransLineCheck


	if not IsDocumentWindow (GetCurrentWindow ())
	&& not IsDocumentWindowJAWSCursor (GetCurrentWindow ()) then
		SayUsingVoice (VCTX_MESSAGE, msgNotInDocument, OT_USER_REQUESTED_INFORMATION)
		return
	endIf
	if IsJawsCursor () then

		PcCursor ()
		SayMessage (OT_STATUS, cmsg9_l, cmsg9_s)
		return
	endIf
	if not CheckTransLine () then
		TypeKey (ksControlF8Press)
		PauseForMovement ()
	endIf
		if CheckTransLine () then
			SayMessage (OT_STATUS, msgTurningOnTransLine, msgSilent)
		else SayMessage (OT_ERROR, msgTransLineNotFound, msgTransLineNotFound)
			return
		endIf
;	endIf
	RouteJAWSToPc ()
	JAWSCursor ()
	MoveToWindow (GetNextWindow (GetNextWindow (GetCurrentWindow ())))
	JawsHome ()
	SayMessage (OT_STATUS, msgJawsCursorOnTransLine, msgJawsCursorOnTransLine)

EndScript


Script ReadLineInBrailleDocToggle ()

	if giBrailleLineSpeakingLevel == 0 then
		SayMessage (OT_STATUS, msgReadBackTrans, msgReadBackTrans)
		let giBrailleLineSpeakingLevel = 2
	elif giBrailleLineSpeakingLevel == 2 then
		SayMessage (OT_STATUS, msgReadBrailleLinesAsBrailleChars, msgReadBrailleLinesAsBrailleChars)
		let giBrailleLineSpeakingLevel = 1
	elif giBrailleLineSpeakingLevel == 1 then
		SayMessage (OT_STATUS, msgSilentBrailleLines, msgSilentBrailleLines)
		let giBrailleLineSpeakingLevel = 0
	endIf

EndScript


Script ReadStyleChangeToggle ()

var
	int nTimesPressed

; if not in a document window, just pass keystroke through to the application
; there was a conflict for Alt+I in the help system
;	toggles through settings for reading style change and skipped lines
	if not IsDocumentWindow (GetCurrentWindow ()) then
		TypeCurrentScriptKey ()
		return
	endIf
	if not gbSkipVerbosity 
	&& not gbStyleChangeVerbosity then
		SayMessage (OT_STATUS, msgSpeakStyleChange, msgSpeakStyleChange)
		SayMessage (OT_STATUS, msgSkipsOff, msgSkipsOff)
		let gbStyleChangeVerbosity = TRUE
	elif gbStyleChangeVerbosity
	&& not gbSkipVerbosity then
		SayMessage (OT_STATUS, msgSpeakStyleChange, msgSpeakStyleChange)
		SayMessage (OT_STATUS, msgSpeakSkips, msgSpeakSkips)
		let gbSkipVerbosity = 1
	elif gbStyleChangeVerbosity
	&& gbSkipVerbosity then
		SayMessage (OT_STATUS, msgStyleChangeOff, msgStyleChangeOff)
		SayMessage (OT_STATUS, msgSpeakSkips, msgSpeakSkips)
		let gbStyleChangeVerbosity = 0
elif not gbStyleChangeVerbosity
	&& gbSkipVerbosity then
		SayMessage (OT_STATUS, msgStyleChangeOff, msgStyleChangeOff)
		SayMessage (OT_STATUS, msgSkipsOff, msgSkipsOff)
		let gbSkipVerbosity = 0
	endIf

EndScript


Script EchoBrailleCharsToggle ()

; if not in a document window, just pass keystroke through to the application
; there was a conflict for Alt+P for Printer Properties
if GetCurrentScriptKeyName () == ksEchoBrailleCharsToggle
		&& not IsDocumentWindow (GetCurrentWindow ()) then
		TypeCurrentScriptKey ()
		return
	endIf
	if gbEchoPC6KeyEntry==0 then
		Say (msgEchoBrailleCharsOn, OT_STATUS)
		let gbEchoPC6KeyEntry = 1
		if nBrailleDoc then
			let nTypingEchoSaved = GetJCFOption(OPT_TYPING_ECHO) ; GetJCFOption(OPT_TYPING_ECHO)
			PauseForMovement ()
			SetJcfOption(OPT_TYPING_ECHO,0) ; echo off
		endIf
	else
		Say (msgEchoBrailleCharsOff, OT_STATUS)
		let gbEchoPC6KeyEntry = 0
		if nBrailleDoc then
;			PauseForMovement ()
			SetJcfOption(OPT_TYPING_ECHO,nTypingEchoSaved) ; restoring saved echo setting
;			SetJcfOption(OPT_TYPING_ECHO,nTypingEchoSaved) ; restoring saved echo setting
		endIf
	endIf

EndScript


Script SayStyleName ()

var
	string sStyleName,
	int nTimesPressed

	let nTimesPressed = IsSameScript ()
	if nTimesPressed > 0
	&& InTable then
		SayUsingVoice (VCTX_MESSAGE, msgRow+sRowNum+" "+msgCol+sColNum, OT_USER_REQUESTED_INFORMATION)
		return
	endIf
	let sStyleName = GetStyleName ()
	if sStyleName == "" then
		SayUsingVoice (VCTX_MESSAGE, msgNotInDocument, OT_USER_REQUESTED_INFORMATION)
	else
		SayUsingVoice (VCTX_MESSAGE, sStyleName, OT_USER_REQUESTED_INFORMATION)
		if BrailleInUse ()
		&& nJFWVersion < 600000 then
			let BrailleModeSave = GetBrailleMode ()
			SetBrailleMode (BRL_MODE_SPEECHBOX)
			let nBrailleTime=0
			while Not (IsKeyWaiting ())
			&& nBrailleTime <= cBrailleMessageTime
				Delay (1)
				let nBrailleTime = nBrailleTime+1
			endWhile
			SetBrailleMode (BrailleModeSave)
			
		endIf
		RestoreCursor ()
	endIf

EndScript


Script SayLocation ()

var
;	string sWindowName,
	string sLocation,
	string sPage,
	string sLine,
	string sColumn,
	int iPagePos

	SayString (GetSelectedText (0, 0))
	let sWindowName = GetWindowName (GetRealWindow (GetCurrentWindow ())) 
	if not IsDocumentWindow (GetCurrentWindow ()) then
		SayUsingVoice (VCTX_MESSAGE, msgNotInDocument, OT_USER_REQUESTED_INFORMATION)
		return
	endIf
	if GetPageNum () == -1 then
		SayMessage (OT_STATUS, msgNoLocation_l, msgNoLocation_s)
		return
	endIf
	let sLine = IntToString (GetLineNum ())
	let sPage = GetPageNum ()
	let sColumn = GetColumnNum ()
	let sLocation = msgPageId+StringTrimTrailingBlanks(sPage)+" "+msgLineId+sLine+" "+msgColId+sColumn
	Say (sLocation, OT_USER_REQUESTED_INFORMATION)
		if BrailleInUse () && nJFWVersion < 600000 then
		let BrailleModeSave = GetBrailleMode ()
		SetBrailleMode (BRL_MODE_SPEECHBOX)
		let nBrailleTime=0
		while Not (IsKeyWaiting ())
		&& nBrailleTime <= cBrailleMessageTime
			Delay (1)
			let nBrailleTime = nBrailleTime+1
		endWhile
		SetBrailleMode (BrailleModeSave)
	endIf
	RestoreCursor ()

EndScript
	

Int Function HandleCustomWindows (handle hWnd)

var
	string sWindowName,
	string buffer,
	handle hWindow,
	int i,
	int nOldBrailleEdit

;	DBTSpeechOn ()
	SendMessage (GetAppMainWindow (GetCurrentWindow ()), 0X0112, /*WM_SYSCOMMAND,*/ 0XF030, 0) /* maximize the window*/
	SendMessage (GetFirstChild (GetFirstChild (GetAppMainWindow (GetCurrentWindow ()))), 0X0112, /*WM_SYSCOMMAND,*/ 0XF030, 0) /* maximize the window*/
	;UIARefresh (0, 1)
	;let i = 0

	PCCursor ()
	let MotionFlag = 1
	let sWindowName = GetWindowName (GetRealWindow (GetCurrentWindow ()))
	let nHighlightCheck = IsDocumentWindow (hWnd)
	let nOldBrailleEdit = nBrailleEdit
	/*if GetWindowClass (hWnd) == wcMDIClient then
;	&& nCustomWindow <= 1 then
		SayMessage (OT_CONTROL_NAME, msgMdiClient)
;	let nCustomWindow = 2
	endIf*/
	if GetWindowName (GetRealWindow (GetCurrentWindow ())) == wnFileNew then
		let nNewDoc = 1
	elif nCustomWindow ==0 then
		let nCustomWindow = 1
	endIf
	let nFocusChange = 1
	let MotionFlag = 1
	let sOldWindowName = sWindowName
	let sWindowName = GetWindowName (GetRealWindow (hwnd))
;	for the Spell checker
	if GetWindowTypeCode (hWnd) == WT_BUTTON
	&& GetWindowName (hWnd) == wnOK
	&& sWindowName == wnSpellCheck then
		let SpellCheckWindow = GetParent (GetCurrentWindow ())
		SpeakSpellCheck ()
		if getScriptAssignedTo (GetCurrentScriptKeyName ()) != "SayWindowPromptAndText"
		;if GetCurrentScriptKeyName () != "Insert+Tab"
		; && GetCurrentScriptKeyName () != "JAWSKey+Tab"
		&& nFocusChange != 3 then
			let nFocusChange = 2
		elif nFocusChange == 3 then
			nFocusChange = 1
		endIf
	;for window that terminates replace dialog
	elif GetWindowTypeCode (hWnd) == WT_BUTTON
	&& GetWindowName (GetCurrentWindow ()) == wnOK
	&& GetWindowName (GetParent (hWnd)) == wnDBT 
	&& GetWindowType (GetParent (hWnd)) == "dialog" then
		MoveToWindow (GetParent (hWnd))
		let hWindow = GetFirstChild (GetCurrentWindow ())
		While GetParent (hWindow) == GetParent (hWnd)
			SayWindowTypeAndText (hWindow)
			let hWindow = GetNextWindow (hWindow)
		endWhile
		MoveToWindow (hWnd)
		return
	endIf
	if sWindowName == msgShortcutPreferences then
		StopSpeech ()
	elif GetWindowClass (GetCurrentWindow ()) == wcDBTWindow
	&& not StringIsBlank (GetStyleName ()) then
		if not nNewDoc then
;			PauseForMovement ()
			let nOldHighlight = nHighlight
			let nHighlightCheck = 1
		else let nHighlight = 0
			let nHighlightCheck = 0
			let nNewDoc = 0
		endIf
	endIf
	if nHighlightCheck then
		let nOldHighlight = nHighlight
			highlighting ()
		endIf
		let nBrailleDoc =IsBrailleDocumentWindow (GetCurrentWindow ()) 
	let nBrailleEdit = nBrailleDoc
	|| nOldBrailleEdit
	&& (StringContains (sWindowName, wnFind)
	|| StringContains (sWindowName, wnReplace))
		if nBrailleEdit
	&& (not nOldBrailleEdit
	|| nBrailleStart) then
			SetJCFOption (OPT_BRL_CONTRACTED_INPUT, 0)
		SetJCFOption (OPT_BRL_G2TRANSLATION, 0)
		SetJCFOption (OPTBRL_Eight_Dot, 0)
		if gbEchoPC6KeyEntry then
			SetJCFOption (OPT_TYPING_ECHO, 0)
		endIf
		let nBrailleStart = 0
	endIf
	if not nBrailleEdit then 
		SetJCFOption (OPT_BRL_G2TRANSLATION, nG2TranslationSaved)
		SetJCFOption (OPT_BRL_G2EXPAND_CURRENT_WORD, nG2ExpandCurrentWordSaved)
		SetJCFOption (OPT_BRL_CONTRACTED_INPUT, nContractedInputSaved)
			SetJCFOption (OPTBRL_Eight_Dot, nEightDotSaved)
		if gbEchoPC6KeyEntry then
			SetJcfOption(OPT_TYPING_ECHO,nTypingEchoSaved) ; restoring  saved echo setting
		endIf
	endIf
	UIARefresh (0, 1)
	RouteBrailleToPc ()
	;HjDialogs should always use older WindowTypeAndText code,
	;So that on Windows 9X PositionInGroup info never misreports items
	If InHjDialog () then
		SayWindowTypeAndText (hWnd)
		;For input edit boxes:
		If GetWindowSubtypeCode (hWnd) == WT_MULTILINE_EDIT then
			SayWindow (hWnd, TRUE)
		EndIf
		Return TRUE
	EndIf
	Return FALSE

EndFunction


Script JAWSBackspace ()

var
	int iIsTop

	if not IsDocumentWindow (GetCurrentWindow ())
 && not (GetWindowClass (GetCurrentWindow ()) == wcDBTCodesEdit)
	|| IsLastKeyRepeating ()then
		DoBackSpace ()
		return
	endIf
	if not PriorCharacter () then
		let iIsTop = 1
	endIf
	if DecipherItemOfText () == 0 then
		if not IIsTop then
			TypeKey(cksDelete)
		endIf
		return
	endIf
	SayTheCharacter ()
	PauseForMovement ()
	if iIsTop then
		return
	else TypeKey(cksDelete)
	endIf

endScript


Script JAWSDelete ()

	if not IsDocumentWindow (GetCurrentWindow ())
	&& not (GetWindowClass (GetCurrentWindow ()) == wcDBTCodesEdit) then
		PerformScript JAWSDelete ()
		return
	endIf
	let iSuppressSameSpot = 1
	TypeKey (cks4)
	PauseForMovement ()
	if nHighlight then
		Highlighting()
	endIf
	if DecipherItemOfText () == 0 then
		return
	endIf
	SayTheCharacter ()
	let iSuppressSameSpot = 0

EndScript



Script CutToClipboard ()

	if not IsDocumentWindow (GetCurrentWindow ())
	&& not (GetWindowClass (GetCurrentWindow ()) == wcDBTCodesEdit) then
		PerformScript CutToClipboard()
		return
	endIf
	PerformScript CutToClipboard ()
	if nHighlight then
		Highlighting()
	endIf

EndScript


Script BrailleRouting ()

;	if GetJcfOption (OPT_BRL_MODE) == 2 then
;		SetJcfOption (OPT_BRL_MODE, BrailleModeSave)
;	endIf
	SaveOldValues ()
	PerformScript BrailleRouting()
	if IsDocumentWindow (GetCurrentWindow ()) then
		PauseForMovement ()
		GetNewValues ()
		PerformScript SayCharacter()
	endIf

EndScript


Int Function IsDocumentWindow (handle hwnd)

;var
;	string sWindowName

	let sWindowName = GetWindowName (GetRealWindow (hwnd))
	if StringContains (sWindowName, scPrintDocument)
		|| StringContains (sWindowName, scBrailleDocument)
		&& IsPCCursor ()
	&& GetWindowClass (GetCurrentWindow ()) == wcDBTWindow
		&& not DialogActive () 
	&& not MenusActive () then
		return 1
	else
		return 0
	endIf

EndFunction


Int Function IsDocumentWindowJAWSCursor (handle hwnd)

;var
;	string sWindowName

	let sWindowName = GetWindowName (GetRealWindow (hwnd))
	if StringContains (sWindowName, scDocument)
		&& IsJAWSCursor () then
		return 1
	else
		return 0
	endIf

EndFunction



int Function IsBrailleDocumentWindow (handle hwnd)

;var
;	string sWindowName

	let sWindowName = GetWindowName (GetRealWindow (hwnd))
	if StringContains (sWindowName, scBrailleDocument) then
;		&& IsPCCursor () 	then
		return 1
	else
		return 0
	endIf

EndFunction


Script ChangeCase ()

var
	string buffer

	TypeCurrentScriptKey ()
	PauseForMovement ()
	PauseForMovement ()
	let buffer = GetSelectedText ()
	StopSpeech ()
	if not StringIsBlank (buffer) then
;OT_CHAR is marked for FS internal use, but we want caps indication
		SayFormattedMessage (OT_CHAR, buffer, buffer)
	else
		SpellWord ()
	endIf

EndScript


Void Function SelectNextCharacter ()

	if not IsDocumentWindow (GetCurrentWindow ()) then
		SelectNextCharacter()
		return
	endIf
	let nSelectCharacter = 1
	if GetJFWVersion () >= 1400000 then
		SayCharacterUnit (2)
	endIf
	if nHighlight then
		NextCharacter ()
	else SelectNextCharacter ()
	endIf

EndFunction


Void Function SelectPriorCharacter ()

	if not IsDocumentWindow (GetCurrentWindow ()) then
		SelectPriorCharacter()
		return
	endIf
	let nSelectCharacter = 1
	if nHighlight then
		PriorCharacter ()
	else SelectPriorCharacter ()
	endIf
	if GetJFWVersion () >= 1400000 then
		SayCharacterUnit (3)
	endIf

EndFunction


Void Function SelectNextWord ()

	if not IsDocumentWindow (GetCurrentWindow ()) then
		SelectNextWord()
		return
	endIf
	let nSelectWord = 1
	if GetJFWVersion () >= 1400000 then
		SayWordUnit (32)
	endIf
	SaveOldValues ()
	if nHighlight then
		NextWord ()
	else SelectNextWord ()
	endIf
	PauseForMovement ()
	GetNewValues ()

EndFunction


Void Function SelectPriorWord ()

	if not IsDocumentWindow (GetCurrentWindow ()) then
		SelectPriorWord()
		return
	endIf
	SaveOldValues ()
	let SaySkipFlag = 1
	let nSelectWord = 1
	if nHighlight then
		PriorWord ()
	else SelectPriorWord ()
	endIf
	if GetJFWVersion () >= 1400000 then
		SayWordUnit (33)
	endIf

EndFunction


Void Function SelectNextLine ()

	if not IsDocumentWindow (GetCurrentWindow ()) then
		SelectNextLine()
		return
	endIf
	if GetJFWVersion () >= 1400000 then
		BrailleLine ()
		SayLineUnit (34)
	endIf
	let nSelectLine = 1
	if nHighlight then
		NextLine ()
	else SelectNextLine ()
	endIf

endFunction


Void Function SelectPriorLine ()

	if not IsDocumentWindow (GetCurrentWindow ()) then
		SelectPriorLine()
		return
	endIf
		let nSelectLine = 1
	if nHighlight then
		PriorLine ()
	else SelectPriorLine ()
	endIf
	if GetJFWVersion () >= 1400000 then
		BrailleLine ()
		SayLineUnit (35)
	endIf

EndFunction


Void Function SayTextSelection (string Select, string sText, int bUseOTChar)

	if nSelectCharacter then
		Say(Select, OT_SELECT)
	elif nSelectWord then
		Say(Select, OT_SELECT)
	elif nSelectLine then
		Say(Select, OT_SELECT)
		let nSelectCharacter = 0
		let nSelectWord = 0
		let nSelectLine = 0
	else SayTextSelection (Select, sText, bUseOTChar)
	endIf

EndFunction


Void Function Highlighting ()

var
	int nCount
		
	if StringToInt (Substring (GetVersionInfoString (GetAppFilePath (), "FileVersion"), 0, 2)) == 12
	&& StringToInt (Substring (GetVersionInfoString (GetAppFilePath (), "FileVersion"), 4, 1)           ) >= 5
	|| StringToInt (Substring (GetVersionInfoString (GetAppFilePath (), "FileVersion"), 0, 2)) > 12 then
		CheckHighlight ()
		return
	endIf
	let nCount = 0
		let nOldHighlight = nHighlight
	if nNewDoc then
		nHighlight = 0
		nNewDoc = 0
		return
	endIf
		/*SaveCursor ()
		InvisibleCursor ()
		RouteInvisibleToPc ()
		JawsPageDown ()
		if GetControlID (GetCurrentWindow ()) != DBT_Window_Control then
			PriorLine ()
			let sLine = GetLine ()
			let nKeysPos = StringContains (sLine, scKeys)
			if SubString (sLine, nKeysPos+6, 1) == "H" then
				SayMessage (OT_STATUS, msgHighlightingOn, msgHighlightingOn) 
			else
				SayMessage (OT_STATUS, msgHighlightingOff, msgHighlightingOff)
			endIf
			if nHighlight && not nOldHighlight then
				SayMessage (OT_SCREEN_MESSAGE, msgHighlightingOn)
			elif not nHighlight && nOldHighlight then
				SayMessage (OT_SCREEN_MESSAGE, msgHighlightingOff)
				return
			endIf
		endIf*/
	RouteInvisibleToPc ()
	SaveCursor ()
	PCCursor ()
	let nStartRow = GetCursorRow ()
	let nStartCol = GetCursorCol ()
	SpeechOff ()
PauseForMovement ()
	while nCount < 4
; 10-25-2016: fixed grouping below
	&& ((GetFromStartOfLine () == ""
	|| GetCursorCol () == nStartCol)
	&& GetCursorRow () == nStartRow)
		NextCharacter ()
		let nCount = nCount+1
		PauseForMovement ()
	endWhile
	if nCount < 2 then
		if GetSelectedText () then
			let nHighlight = 1
		else let nHighlight = 0
		endIf
		PriorCharacter ()
	else let nCount = 0
		while nCount < 4
; 10-25-2016: fixed grouping below
		&& ((GetToEndOfLine () == ""
		|| GetCursorCol () == nStartCol)
		&& GetCursorRow () == nStartRow)
;			PauseForMovement ()
			PriorCharacter ()
			let nCount = nCount+1
			PauseForMovement ()
		endWhile
		if GetSelectedText () then
					let nHighlight = 1
		else let nHighlight = 0
		endIf
		NextCharacter ()
	endIf
	InvisibleCursor ()
	RestoreCursor ()
	RoutePCToInvisible ()
	PCCursor ()
	DBTSpeechOn ()
	if nHighlight /*&& not nOldHighlight*/ then
		SayMessage (OT_SCREEN_MESSAGE, msgHighlightingOn)
	elif not nHighlight && nOldHighlight then
		SayMessage (OT_SCREEN_MESSAGE, msgHighlightingOff)
	endIf

EndFunction


Void Function ScreenStabilizedEvent (handle LastScreenWrite)

	if (GetWindowName (LastScreenWrite) == wnSuggestedReplacements
	|| GetWindowName (GetParent (GetCurrentWindow ())) == wnSpellCheck)
	&& GetWindowName (GetCurrentWindow ()) == wnOK then
		if nFocusChange == 2 then
			let nFocusChange = 1
		else SpeakSpellCheck ()
			SayWindowTypeAndText (GetCurrentWindow ())
			let nFocusChange = 1 
			return
		endIf 
	endIf
	if (IsDocumentWindow (GetPriorWindow (GetPriorWindow (LastScreenWrite)))) then
		let MotionFlag = 0
		endIf
		let MotionFlag = 0
	
EndFunction


Void Function IndicateComputerBraille ()

; Overrides the default function, to avoid having JAWS
	; say "computer braille" wen focus changes.

EndFunction


Script SayLinePosition ()

Var
	int nAgain,
	int nFullLength,
	int nPosition,
	int nToEnd

	Let nAgain = IsSameScript ()
	let nFullLength = StringLength (GetLine ())
	Let nToEnd = StringLength (GetToEndOfLine ())
	Let nPosition = nFullLength - nToEnd+1
	If nAgain == 0 Then
		PauseForMovement ()
		PauseForMovement ()
		if nToEnd == 0 then
			Say (msgLinePosition+IntToString (nPosition)+" "+msgEndOfLine, FALSE)
		else
			Say (msgLinePosition+" "+IntToString (nPosition), FALSE)
		endIf
	ElIf nAgain == 1 Then
		Say (IntToString (nToEnd-1)+" "+msgToEndOfLine, FALSE)
	endIf

endScript


Script SayTotalAndLeftOffset ()

var
	int nAgain,
	int nFullLength,
	int nTextLength
	if not StringContains (GetWindowName (GetRealWindow (GetCurrentWindow ())), scDocument) then
		SayUsingVoice (VCTX_MESSAGE, msgNotInDocument, OT_USER_REQUESTED_INFORMATION)
		return
	elif GetLineNum() == -1 then
		SayMessage (OT_STATUS, msgCodesOn_l, msgCodesOn_s)
		return
	endIf
	Let nAgain = IsSameScript ()
	let nFullLength = StringLength (GetLine ())
	let nTextLength = StringLength (StringTrimLeadingBlanks (GetLine ()))
	if nAgain == 0 then
		PauseForMovement ()
		PauseForMovement ()
		Say (IntToString (nFullLength)+" "+msgTotalCharacters, FALSE)
	elif nAgain == 1 then
		Say (IntToString (nFullLength - nTextLength)+" "+msgLeftSpaces, FALSE)
	endIf

EndScript


Script SpeakLastWord ()			

	if not IsDocumentWindow (GetCurrentWindow ()) then
		SayUsingVoice (VCTX_MESSAGE, msgNotInDocument, OT_USER_REQUESTED_INFORMATION)
		return
	endIf
	if GetPageNum () == -1 then
		SayMessage (OT_STATUS, msgNoLocation_l, msgNoLocation_s)
		return
	endIf
	if nBrailleEdit then
		SpeakStringAsBrailleCells (VCTX_JAWSCURSOR, StringSegment (GetLine (), " -", -1))
	else
		Say (StringSegment (GetLine (), " -", -1), OT_USER_REQUESTED_INFORMATION)
	endIf

EndScript


Void Function SaveOldValues ()

	let MotionFlag = 1
	let SaySkipFlag = 0
	let OldStyleName = StyleName
	let OldPageNum = PageNum
	let OldLineNum = LineNum
	let sOldRowNum = sRowNum
	let sOldColNum = sColNum

EndFunction


Void Function GetNewValues ()

var
	int x

	let PageNum = GetPageNum ()
	let LineNum = GetLineNum ()
	let StyleName = GetStyleName ()
	if PageNum != OldPageNum
	&& PageNum != -1
; below, don't say word "page" when entering a code or DUSCI number
	&& not DialogActive () then
		SayUsingVoice (VCTX_MESSAGE, msgPage+PageNum, OT_STATUS)
	endIf
	let LineNum = GetLineNum ()
	let x = Max ((LineNum-OldLineNum), (OldLineNum-LineNum))
	if x > 1
	&& SaySkipFlag
	&& PageNum == OldPageNum
	&& gbSkipVerbosity then
		SayUsingVoice (VCTX_MESSAGE, msgLineSkip, OT_STATUS)
	endIf
	if gbStyleChangeVerbosity
	;&& MotionFlag
	&& StyleName != OldStyleName
	&& StyleName != "-1" then
		SayUsingVoice (VCTX_MESSAGE, GetStyleName (), OT_STATUS)
	endIf
		if sRowNum != sOldRowNum then
	/*&& sRowNum != "-1" then*/
			SayUsingVoice (VCTX_MESSAGE, msgRow+sRowNum, OT_STATUS)
		elif sColNum != sOldColNum then
	/*&& sColNum != "-1" then*/
			SayUsingVoice (VCTX_MESSAGE, msgCol+sColNum, OT_STATUS)
	endIf
	let MotionFlag = 0

EndFunction



Void Function SpeakSpellCheck ()

	SaveCursor ()
	InvisibleCursor ()
	MoveToWindow (SpellCheckWindow)
	NextLine ()
	NextLine ()
	SayLine ()
	JAWSEnd ()
	SayWord ()
	SayMessage (OT_JAWS_MESSAGE, msgSpelled, msgSilent)
		SpellString (GetWord ())
	BrailleMessage (GetWord (), 0, 5000)
PCCursor ()
	RestoreCursor ()

EndFunction

 
Script ReadWordInContext ()

	PerformScript ReadWordInContext ()
	if BrailleInUse () then
		RouteBrailleToJAWS ()
		if IsKeyWaiting () then
			RouteBrailleToPC ()
		endIf
	endIf		

EndScript


Void Function LoadNonJCFOptions ()

	let giBrailleLineSpeakingLevel = GetNonJCFOption ("BrailleLineSpeakingLevel")-1
	let gbEchoPC6KeyEntry = GetNonJCFOption ("EchoPC6KeyEntry")
	let gbAnnounceBrailleCharsAsLocalBrailleSigns = GetNonJCFOption ("SpeakBrailleCharsAsLocalBrailleSigns")
	let gbStyleChangeVerbosity = GetNonJCFOption ("AnnounceStyleChanges")
	let gbSkipVerbosity = GetNonJCFOption ("AnnounceForcedLineSkips")
	
EndFunction


Function QuickSettings ()
let MotionFlag = 1
if getRunningFSProducts () == product_MAGic then
	;do nothing if MAGic-specific limitations are not met:
;	if  ! gbSupportsMAGicOptions && ! isVirtualPcCursor () && ! IsFormsModeActive () then
;		return
;	endIf
endIf
If !AreUtilitiesAllowed() then
	return
endIf
if InHJDialog () then
	SayFormattedMessage (OT_error, cMSG337_L, cMSG337_S)
	return
endIf
QuickSettingsPreProcess ()
LaunchQuickSettings ()
delay (2, TRUE)
loadNonJCFOptions (); update application-wide options.
SetUpStuffForNewPage (TRUE)
QuickSettingsPostProcess ()
QuickSettingsLoadDocumentSettings ()
EndFunction


void function QuickSettingsPreProcess ()
;Code goes here which runs before loading the Quick Settings tool.
let gbOldEchoPC6KeyEntry = gbEchoPC6KeyEntry

endFunction


String Function GetLastBrailleInput ()

var
	string sWord
	
	if GetCharacterValue (GetPriorCharacter ()) != 0 then
		return GetPriorCharacter ()
	else let sWord = GetWord ()
		return (Substring (sWord, StringLength(sWord), 1))
	endIf

EndFunction


Void Function CheckHighlight ()

var
	string sLine

	SaveCursor ()
  	InvisibleCursor ()
	RouteInvisibleToPc ()
	SetRestriction (RestrictRealWindow)
	JawsPageDown ()
	if GetControlID (GetCurrentWindow ()) != DBT_Window_Control then
		PriorLine ()
	endIf
	let sLine = GetLine ()
	let nKeysPos = StringContains (sLine, scKeys)
	if SubString (sLine, nKeysPos+6, 1) == "h" then
		let nHighlight = 1
	else
		let nHighlight = 0
	endIf
	if nHighlight && not nOldHighlight then
		SayMessage (OT_SCREEN_MESSAGE, msgHighlightingOn)
	elif not nHighlight && nOldHighlight then
		SayMessage (OT_SCREEN_MESSAGE, msgHighlightingOff)
	endIf 

EndFunction


void function ProcessKeyPressed(int nKey, string strKeyName, int nIsBrailleKey, int nIsScriptKey)
;This function can be used to specify behavior in KeyPressedEvent which does not belong in any of the other functions called by that event.
;Currently, the other function are:
;PreProcessKeyPressedEvent, intended for all code which must be processed before any other
;ProcessHJDialogKeyPressed, handles all special processing for HJ dialogs
;ProcessSpaceBarKeyPressed, intended to be overwritten for any behavior tied to the spacebar
	let nOldHighlight = nHighlight
	/*if not StringContains (strKeyName, "Arrow") then
		UIARefresh (0, 1)
	endIf*/
	if StringContains (strKeyName, "Control+H") then
		highlighting () 
	endIf 
	
endFunction


Function ProcessEventOnFocusChangedEvent (handle AppWindow, handle RealWindow, string RealWindowName, handle FocusWindow, handle PrevWindow)

	if nStartingDBT then
		ProcessSayAppWindowOnFocusChange(AppWindow, FocusWindow)
		let nStartingDBT = 0
	elif IsDocumentWindow (FocusWindow) then
		ProcessSayRealWindowOnFocusChange(AppWindow,RealWindow,RealWindowName,FocusWindow)
	else ProcessEventOnFocusChangedEvent(AppWindow, RealWindow, RealWindowName, FocusWindow, PrevWindow)
endIf
	
	endFunction

